build.sh 19 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708
  1. #!/usr/bin/env bash
  2. # Copyright 2018 Google
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # USAGE: build.sh product [platform] [method]
  16. #
  17. # Builds the given product for the given platform using the given build method
  18. function pod_gen() {
  19. # Call pod gen with a podspec and additional optional arguments.
  20. bundle exec pod gen --local-sources=./ --sources=https://github.com/firebase/SpecsDev.git,https://github.com/firebase/SpecsStaging.git,https://cdn.cocoapods.org/ "$@"
  21. }
  22. set -euo pipefail
  23. if [[ $# -lt 1 ]]; then
  24. cat 1>&2 <<EOF
  25. USAGE: $0 product [platform] [method]
  26. product can be one of:
  27. Firebase
  28. Firestore
  29. CombineSwift
  30. InAppMessaging
  31. Messaging
  32. MessagingSample
  33. SwiftUISample
  34. MLModelDownloaderSample
  35. RemoteConfig
  36. RemoteConfigSample
  37. Sessions
  38. Storage
  39. SymbolCollision
  40. GoogleDataTransport
  41. Performance
  42. ClientApp
  43. platform can be one of:
  44. iOS (default)
  45. iOS-device
  46. macOS
  47. tvOS
  48. watchOS
  49. catalyst
  50. visionOS
  51. method can be one of:
  52. xcodebuild (default)
  53. cmake
  54. unit
  55. integration
  56. spm
  57. Optionally, reads the environment variable SANITIZERS. If set, it is expected to
  58. be a string containing a space-separated list with some of the following
  59. elements:
  60. asan
  61. tsan
  62. ubsan
  63. EOF
  64. exit 1
  65. fi
  66. product="$1"
  67. platform="iOS"
  68. if [[ $# -gt 1 ]]; then
  69. platform="$2"
  70. fi
  71. method="xcodebuild"
  72. if [[ $# -gt 2 ]]; then
  73. method="$3"
  74. fi
  75. echo "Building $product for $platform using $method"
  76. if [[ -n "${SANITIZERS:-}" ]]; then
  77. echo "Using sanitizers: $SANITIZERS"
  78. fi
  79. scripts_dir=$(dirname "${BASH_SOURCE[0]}")
  80. firestore_emulator="${scripts_dir}/run_firestore_emulator.sh"
  81. database_emulator="${scripts_dir}/run_database_emulator.sh"
  82. system=$(uname -s)
  83. case "$system" in
  84. Darwin)
  85. xcode_version=$(xcodebuild -version | head -n 1)
  86. xcode_version="${xcode_version/Xcode /}"
  87. xcode_major="${xcode_version/.*/}"
  88. ;;
  89. *)
  90. xcode_major="0"
  91. ;;
  92. esac
  93. # Source function to check if CI secrets are available.
  94. source scripts/check_secrets.sh
  95. # Runs xcodebuild with the given flags, piping output to xcpretty
  96. # If xcodebuild fails with known error codes, retries once.
  97. function RunXcodebuild() {
  98. echo xcodebuild "$@"
  99. xcpretty_cmd=(xcpretty)
  100. result=0
  101. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  102. if [[ $result == 65 ]]; then
  103. ExportLogs "$@"
  104. echo "xcodebuild exited with 65, retrying" 1>&2
  105. sleep 5
  106. result=0
  107. xcodebuild "$@" | tee xcodebuild.log | "${xcpretty_cmd[@]}" || result=$?
  108. fi
  109. if [[ $result != 0 ]]; then
  110. echo "xcodebuild exited with $result" 1>&2
  111. ExportLogs "$@"
  112. return $result
  113. fi
  114. }
  115. # Exports any logs output captured in the xcresult
  116. function ExportLogs() {
  117. python "${scripts_dir}/xcresult_logs.py" "$@"
  118. }
  119. if [[ "$xcode_major" -lt 15 ]]; then
  120. ios_flags=(
  121. -sdk 'iphonesimulator'
  122. -destination 'platform=iOS Simulator,name=iPhone 14'
  123. )
  124. else
  125. ios_flags=(
  126. -sdk 'iphonesimulator'
  127. -destination 'platform=iOS Simulator,name=iPhone 15'
  128. )
  129. fi
  130. ios_device_flags=(
  131. -sdk 'iphoneos'
  132. -destination 'generic/platform=iOS'
  133. )
  134. ipad_flags=(
  135. -sdk 'iphonesimulator'
  136. -destination 'platform=iOS Simulator,name=iPad Pro (9.7-inch)'
  137. )
  138. macos_flags=(
  139. -sdk 'macosx'
  140. -destination 'platform=OS X,arch=x86_64'
  141. )
  142. tvos_flags=(
  143. -sdk "appletvsimulator"
  144. -destination 'platform=tvOS Simulator,name=Apple TV'
  145. )
  146. watchos_flags=(
  147. -destination 'platform=watchOS Simulator,name=Apple Watch Series 7 (45mm)'
  148. )
  149. visionos_flags=(
  150. -destination 'platform=visionOS Simulator'
  151. )
  152. catalyst_flags=(
  153. ARCHS=x86_64 VALID_ARCHS=x86_64 SUPPORTS_MACCATALYST=YES -sdk macosx
  154. -destination platform="macOS,variant=Mac Catalyst,arch=x86_64" TARGETED_DEVICE_FAMILY=2
  155. CODE_SIGN_IDENTITY=- CODE_SIGNING_REQUIRED=NO CODE_SIGNING_ALLOWED=NO
  156. )
  157. # Compute standard flags for all platforms
  158. case "$platform" in
  159. iOS)
  160. xcb_flags=("${ios_flags[@]}")
  161. gen_platform=ios
  162. ;;
  163. iOS-device)
  164. xcb_flags=("${ios_device_flags[@]}")
  165. gen_platform=ios
  166. ;;
  167. iPad)
  168. xcb_flags=("${ipad_flags[@]}")
  169. ;;
  170. macOS)
  171. xcb_flags=("${macos_flags[@]}")
  172. gen_platform=macos
  173. ;;
  174. tvOS)
  175. xcb_flags=("${tvos_flags[@]}")
  176. gen_platform=tvos
  177. ;;
  178. watchOS)
  179. xcb_flags=("${watchos_flags[@]}")
  180. ;;
  181. visionOS)
  182. xcb_flags=("${visionos_flags[@]}")
  183. ;;
  184. catalyst)
  185. xcb_flags=("${catalyst_flags[@]}")
  186. ;;
  187. all)
  188. xcb_flags=()
  189. ;;
  190. Linux)
  191. xcb_flags=()
  192. ;;
  193. *)
  194. echo "Unknown platform '$platform'" 1>&2
  195. exit 1
  196. ;;
  197. esac
  198. xcb_flags+=(
  199. ONLY_ACTIVE_ARCH=YES
  200. CODE_SIGNING_REQUIRED=NO
  201. CODE_SIGNING_ALLOWED=YES
  202. COMPILER_INDEX_STORE_ENABLE=NO
  203. )
  204. source scripts/buildcache.sh
  205. xcb_flags=("${xcb_flags[@]}" "${buildcache_xcb_flags[@]}")
  206. # TODO(varconst): Add --warn-unused-vars and --warn-uninitialized.
  207. # Right now, it makes the log overflow on Travis because many of our
  208. # dependencies don't build cleanly this way.
  209. cmake_options=(
  210. -Wdeprecated
  211. -DCMAKE_BUILD_TYPE=Debug
  212. )
  213. if [[ -n "${SANITIZERS:-}" ]]; then
  214. for sanitizer in $SANITIZERS; do
  215. case "$sanitizer" in
  216. asan)
  217. xcb_flags+=(
  218. -enableAddressSanitizer YES
  219. )
  220. cmake_options+=(
  221. -DWITH_ASAN=ON
  222. )
  223. ;;
  224. tsan)
  225. xcb_flags+=(
  226. -enableThreadSanitizer YES
  227. )
  228. cmake_options+=(
  229. -DWITH_TSAN=ON
  230. )
  231. ;;
  232. ubsan)
  233. xcb_flags+=(
  234. -enableUndefinedBehaviorSanitizer YES
  235. )
  236. cmake_options+=(
  237. -DWITH_UBSAN=ON
  238. )
  239. ;;
  240. *)
  241. echo "Unknown sanitizer '$sanitizer'" 1>&2
  242. exit 1
  243. ;;
  244. esac
  245. done
  246. fi
  247. case "$product-$platform-$method" in
  248. FirebasePod-iOS-*)
  249. RunXcodebuild \
  250. -workspace 'CoreOnly/Tests/FirebasePodTest/FirebasePodTest.xcworkspace' \
  251. -scheme "FirebasePodTest" \
  252. "${xcb_flags[@]}" \
  253. build
  254. ;;
  255. Auth-*-xcodebuild)
  256. if check_secrets; then
  257. RunXcodebuild \
  258. -workspace 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcworkspace' \
  259. -scheme "ObjCApiTests" \
  260. "${xcb_flags[@]}" \
  261. test
  262. RunXcodebuild \
  263. -workspace 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcworkspace' \
  264. -scheme "SwiftApiTests" \
  265. "${xcb_flags[@]}" \
  266. test
  267. RunXcodebuild \
  268. -workspace 'FirebaseAuth/Tests/SampleSwift/AuthenticationExample.xcworkspace' \
  269. -scheme "AuthenticationExampleUITests" \
  270. "${xcb_flags[@]}" \
  271. build \
  272. test
  273. fi
  274. ;;
  275. CombineSwift-*-xcodebuild)
  276. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  277. RunXcodebuild \
  278. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  279. -scheme "FirebaseCombineSwift-Unit-unit" \
  280. "${xcb_flags[@]}" \
  281. build \
  282. test
  283. ;;
  284. InAppMessaging-*-xcodebuild)
  285. RunXcodebuild \
  286. -workspace 'FirebaseInAppMessaging/Tests/Integration/DefaultUITestApp/InAppMessagingDisplay-Sample.xcworkspace' \
  287. -scheme 'FiamDisplaySwiftExample' \
  288. "${xcb_flags[@]}" \
  289. test
  290. ;;
  291. Firestore-*-xcodebuild)
  292. "${firestore_emulator}" start
  293. trap '"${firestore_emulator}" stop' ERR EXIT
  294. RunXcodebuild \
  295. -workspace 'Firestore/Example/Firestore.xcworkspace' \
  296. -scheme "Firestore_IntegrationTests_$platform" \
  297. -enableCodeCoverage YES \
  298. "${xcb_flags[@]}" \
  299. test
  300. ;;
  301. Firestore-macOS-cmake | Firestore-Linux-cmake)
  302. "${firestore_emulator}" start
  303. trap '"${firestore_emulator}" stop' ERR EXIT
  304. (
  305. test -d build || mkdir build
  306. cd build
  307. echo "Preparing cmake build ..."
  308. cmake -G Ninja "${cmake_options[@]}" ..
  309. echo "Building cmake build ..."
  310. ninja -k 10 all
  311. ctest --verbose
  312. )
  313. ;;
  314. SymbolCollision-*-*)
  315. RunXcodebuild \
  316. -workspace 'SymbolCollisionTest/SymbolCollisionTest.xcworkspace' \
  317. -scheme "SymbolCollisionTest" \
  318. "${xcb_flags[@]}" \
  319. build
  320. ;;
  321. # TODO(#12205) Restore this test to "test" instead of "build"
  322. Messaging-*-xcodebuild)
  323. pod_gen FirebaseMessaging.podspec --platforms=ios
  324. # Add GoogleService-Info.plist to generated Test Wrapper App.
  325. ruby ./scripts/update_xcode_target.rb gen/FirebaseMessaging/Pods/Pods.xcodeproj \
  326. AppHost-FirebaseMessaging-Unit-Tests \
  327. ../../../FirebaseMessaging/Tests/IntegrationTests/Resources/GoogleService-Info.plist
  328. if check_secrets; then
  329. # Integration tests are only run on iOS to minimize flake failures.
  330. RunXcodebuild \
  331. -workspace 'gen/FirebaseMessaging/FirebaseMessaging.xcworkspace' \
  332. -scheme "FirebaseMessaging-Unit-integration" \
  333. "${ios_flags[@]}" \
  334. "${xcb_flags[@]}" \
  335. build
  336. fi
  337. ;;
  338. MessagingSample-*-*)
  339. if check_secrets; then
  340. RunXcodebuild \
  341. -workspace 'FirebaseMessaging/Apps/Sample/Sample.xcworkspace' \
  342. -scheme "Sample" \
  343. "${xcb_flags[@]}" \
  344. build
  345. fi
  346. ;;
  347. SwiftUISample-*-*)
  348. if check_secrets; then
  349. RunXcodebuild \
  350. -workspace 'FirebaseMessaging/Apps/SwiftUISample/SwiftUISample.xcworkspace' \
  351. -scheme "SwiftUISample" \
  352. "${xcb_flags[@]}" \
  353. build
  354. fi
  355. ;;
  356. MessagingSampleStandaloneWatchApp-*-*)
  357. if check_secrets; then
  358. RunXcodebuild \
  359. -workspace 'FirebaseMessaging/Apps/SampleStandaloneWatchApp/SampleStandaloneWatchApp.xcworkspace' \
  360. -scheme "SampleStandaloneWatchApp Watch App" \
  361. "${xcb_flags[@]}" \
  362. build
  363. fi
  364. ;;
  365. MLModelDownloaderSample-*-*)
  366. if check_secrets; then
  367. RunXcodebuild \
  368. -workspace 'FirebaseMLModelDownloader/Apps/Sample/MLDownloaderTestApp.xcworkspace' \
  369. -scheme "MLDownloaderTestApp" \
  370. "${xcb_flags[@]}" \
  371. build
  372. fi
  373. ;;
  374. WatchOSSample-*-*)
  375. RunXcodebuild \
  376. -workspace 'Example/watchOSSample/SampleWatchApp.xcworkspace' \
  377. -scheme "SampleWatchAppWatchKitApp" \
  378. "${xcb_flags[@]}" \
  379. build
  380. ;;
  381. Database-*-integration)
  382. "${database_emulator}" start
  383. trap '"${database_emulator}" stop' ERR EXIT
  384. pod_gen FirebaseDatabase.podspec --platforms="${gen_platform}"
  385. RunXcodebuild \
  386. -workspace 'gen/FirebaseDatabase/FirebaseDatabase.xcworkspace' \
  387. -scheme "FirebaseDatabase-Unit-integration" \
  388. "${xcb_flags[@]}" \
  389. build \
  390. test
  391. ;;
  392. RemoteConfig-*-fakeconsole)
  393. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  394. RunXcodebuild \
  395. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  396. -scheme "FirebaseRemoteConfigSwift-Unit-fake-console-tests" \
  397. "${xcb_flags[@]}" \
  398. build \
  399. test
  400. ;;
  401. RemoteConfig-*-integration)
  402. pod_gen FirebaseRemoteConfigSwift.podspec --platforms="${gen_platform}"
  403. # Add GoogleService-Info.plist to generated Test Wrapper App.
  404. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  405. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  406. ../../../FirebaseRemoteConfigSwift/Tests/SwiftAPI/GoogleService-Info.plist
  407. # Add AccessToken to generated Test Wrapper App.
  408. ruby ./scripts/update_xcode_target.rb gen/FirebaseRemoteConfigSwift/Pods/Pods.xcodeproj \
  409. AppHost-FirebaseRemoteConfigSwift-Unit-Tests \
  410. ../../../FirebaseRemoteConfigSwift/Tests/AccessToken.json
  411. RunXcodebuild \
  412. -workspace 'gen/FirebaseRemoteConfigSwift/FirebaseRemoteConfigSwift.xcworkspace' \
  413. -scheme "FirebaseRemoteConfigSwift-Unit-swift-api-tests" \
  414. "${xcb_flags[@]}" \
  415. build \
  416. test
  417. ;;
  418. RemoteConfigSample-*-*)
  419. RunXcodebuild \
  420. -workspace 'FirebaseRemoteConfig/Tests/Sample/RemoteConfigSampleApp.xcworkspace' \
  421. -scheme "RemoteConfigSampleApp" \
  422. "${xcb_flags[@]}" \
  423. build
  424. ;;
  425. Sessions-*-integration)
  426. # Perform "pod install" to install the relevant dependencies
  427. # ./FirebaseSessions/generate_testapp.sh
  428. pod_gen FirebaseSessions.podspec --platforms=ios --clean
  429. cd FirebaseSessions/Tests/TestApp; pod install; cd -
  430. # Run E2E Integration Tests for Prod.
  431. RunXcodebuild \
  432. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  433. -scheme "AppQualityDevApp_iOS" \
  434. "${ios_flags[@]}" \
  435. "${xcb_flags[@]}" \
  436. build \
  437. test
  438. # Run E2E Integration Tests for Staging.
  439. RunXcodebuild \
  440. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  441. -scheme "AppQualityDevApp_iOS" \
  442. FirebaseSessionsRunEnvironment=STAGING \
  443. "${ios_flags[@]}" \
  444. "${xcb_flags[@]}" \
  445. build \
  446. test
  447. # Run E2E Integration Tests for Autopush.
  448. RunXcodebuild \
  449. -workspace 'FirebaseSessions/Tests/TestApp/AppQualityDevApp.xcworkspace' \
  450. -scheme "AppQualityDevApp_iOS" \
  451. FirebaseSessionsRunEnvironment=AUTOPUSH \
  452. "${ios_flags[@]}" \
  453. "${xcb_flags[@]}" \
  454. build \
  455. test
  456. ;;
  457. StorageSwift-*-xcodebuild)
  458. pod_gen FirebaseStorage.podspec --platforms=ios
  459. # Add GoogleService-Info.plist to generated Test Wrapper App.
  460. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  461. AppHost-FirebaseStorage-Unit-Tests \
  462. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  463. if check_secrets; then
  464. # Integration tests are only run on iOS to minimize flake failures.
  465. RunXcodebuild \
  466. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  467. -scheme "FirebaseStorage-Unit-integration" \
  468. "${ios_flags[@]}" \
  469. "${xcb_flags[@]}" \
  470. test
  471. fi
  472. ;;
  473. StorageObjC-*-xcodebuild)
  474. pod_gen FirebaseStorage.podspec --platforms=ios
  475. # Add GoogleService-Info.plist to generated Test Wrapper App.
  476. ruby ./scripts/update_xcode_target.rb gen/FirebaseStorage/Pods/Pods.xcodeproj \
  477. AppHost-FirebaseStorage-Unit-Tests \
  478. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  479. if check_secrets; then
  480. # Integration tests are only run on iOS to minimize flake failures.
  481. RunXcodebuild \
  482. -workspace 'gen/FirebaseStorage/FirebaseStorage.xcworkspace' \
  483. -scheme "FirebaseStorage-Unit-ObjCIntegration" \
  484. "${ios_flags[@]}" \
  485. "${xcb_flags[@]}" \
  486. test
  487. fi
  488. ;;
  489. StorageCombine-*-xcodebuild)
  490. pod_gen FirebaseCombineSwift.podspec --platforms=ios
  491. # Add GoogleService-Info.plist to generated Test Wrapper App.
  492. ruby ./scripts/update_xcode_target.rb gen/FirebaseCombineSwift/Pods/Pods.xcodeproj \
  493. AppHost-FirebaseCombineSwift-Unit-Tests \
  494. ../../../FirebaseStorage/Tests/Integration/Resources/GoogleService-Info.plist
  495. if check_secrets; then
  496. # Integration tests are only run on iOS to minimize flake failures.
  497. RunXcodebuild \
  498. -workspace 'gen/FirebaseCombineSwift/FirebaseCombineSwift.xcworkspace' \
  499. -scheme "FirebaseCombineSwift-Unit-integration" \
  500. "${ios_flags[@]}" \
  501. "${xcb_flags[@]}" \
  502. test
  503. fi
  504. ;;
  505. GoogleDataTransport-watchOS-xcodebuild)
  506. RunXcodebuild \
  507. -workspace 'GoogleDataTransport/GDTWatchOSTestApp/GDTWatchOSTestApp.xcworkspace' \
  508. -scheme "GDTWatchOSTestAppWatchKitApp" \
  509. "${xcb_flags[@]}" \
  510. build
  511. RunXcodebuild \
  512. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  513. -scheme "GDTCCTWatchOSIndependentTestAppWatchKitApp" \
  514. "${xcb_flags[@]}" \
  515. build
  516. RunXcodebuild \
  517. -workspace 'GoogleDataTransport/GDTCCTWatchOSTestApp/GDTCCTWatchOSTestApp.xcworkspace' \
  518. -scheme "GDTCCTWatchOSCompanionTestApp" \
  519. "${xcb_flags[@]}" \
  520. build
  521. ;;
  522. Performance-*-unit)
  523. # Run unit tests on prod environment with unswizzle capabilities.
  524. export FPR_UNSWIZZLE_AVAILABLE="1"
  525. export FPR_AUTOPUSH_ENV="0"
  526. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  527. RunXcodebuild \
  528. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  529. -scheme "FirebasePerformance-Unit-unit" \
  530. "${xcb_flags[@]}" \
  531. build \
  532. test
  533. ;;
  534. Performance-*-proddev)
  535. # Build the prod dev test app.
  536. export FPR_UNSWIZZLE_AVAILABLE="0"
  537. export FPR_AUTOPUSH_ENV="0"
  538. pod_gen FirebasePerformance.podspec --platforms="${gen_platform}"
  539. RunXcodebuild \
  540. -workspace 'gen/FirebasePerformance/FirebasePerformance.xcworkspace' \
  541. -scheme "FirebasePerformance-TestApp" \
  542. "${xcb_flags[@]}" \
  543. build
  544. ;;
  545. Performance-*-integration)
  546. # Generate the workspace for the SDK to generate Protobuf files.
  547. export FPR_UNSWIZZLE_AVAILABLE="0"
  548. pod_gen FirebasePerformance.podspec --platforms=ios --clean
  549. # Perform "pod install" to install the relevant dependencies
  550. cd FirebasePerformance/Tests/FIRPerfE2E; pod install; cd -
  551. # Run E2E Integration Tests for Autopush.
  552. RunXcodebuild \
  553. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  554. -scheme "FIRPerfE2EAutopush" \
  555. FPR_AUTOPUSH_ENV=1 \
  556. "${ios_flags[@]}" \
  557. "${xcb_flags[@]}" \
  558. build \
  559. test
  560. # Run E2E Integration Tests for Prod.
  561. RunXcodebuild \
  562. -workspace 'FirebasePerformance/Tests/FIRPerfE2E/FIRPerfE2E.xcworkspace' \
  563. -scheme "FIRPerfE2EProd" \
  564. "${ios_flags[@]}" \
  565. "${xcb_flags[@]}" \
  566. build \
  567. test
  568. ;;
  569. # Note that the combine tests require setting the minimum iOS and tvOS version to 13.0
  570. *-*-spm)
  571. RunXcodebuild \
  572. -scheme $product \
  573. "${xcb_flags[@]}" \
  574. IPHONEOS_DEPLOYMENT_TARGET=13.0 \
  575. TVOS_DEPLOYMENT_TARGET=13.0 \
  576. test
  577. ;;
  578. *-*-spmbuildonly)
  579. RunXcodebuild \
  580. -scheme $product \
  581. "${xcb_flags[@]}" \
  582. build
  583. ;;
  584. ClientApp-iOS-xcodebuild | ClientApp-iOS13-iOS-xcodebuild)
  585. RunXcodebuild \
  586. -project 'IntegrationTesting/ClientApp/ClientApp.xcodeproj' \
  587. -scheme $product \
  588. "${xcb_flags[@]}" \
  589. build
  590. ;;
  591. ClientApp-CocoaPods*-iOS-xcodebuild)
  592. RunXcodebuild \
  593. -workspace 'IntegrationTesting/ClientApp/ClientApp.xcworkspace' \
  594. -scheme $product \
  595. "${xcb_flags[@]}" \
  596. build
  597. ;;
  598. *)
  599. echo "Don't know how to build this product-platform-method combination" 1>&2
  600. echo " product=$product" 1>&2
  601. echo " platform=$platform" 1>&2
  602. echo " method=$method" 1>&2
  603. exit 1
  604. ;;
  605. esac